Attribute VB_Name = "modFileTime"
'CopyRight (c) Eurora3D 2008

'Pre upotrebe KOMPAJLOVATI :)
'Ako se izvodi u VB IDE moze da ga blokira

Public Type FileTime
dwLowDateTime As Long
dwHighDateTime As Long
End Type

Public Type SYSTEMTIME
        wYear As Integer
        wMonth As Integer
        wDayOfWeek As Integer
        wDay As Integer
        wHour As Integer
        wMinute As Integer
        wSecond As Integer
        wMilliseconds As Integer
End Type

Public Type SECURITY_ATTRIBUTES
        nLength As Long
        lpSecurityDescriptor As Long
        bInheritHandle As Long
End Type

Public Const GENERIC_READ = &H80000000
Public Const FILE_SHARE_READ = &H1
Public Const OPEN_EXISTING = 3
Public Const FILE_ATTRIBUTE_NORMAL = &H80

Public Declare Function GetFileTime Lib "kernel32" (ByVal hFile As Long, lpCreationTime As FileTime, lpLastAccessTime As FileTime, lpLastWriteTime As FileTime) As Long
Public Declare Function FileTimeToLocalFileTime Lib "kernel32" (lpFileTime As FileTime, lpLocalFileTime As FileTime) As Long
Public Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FileTime, lpSystemTime As SYSTEMTIME) As Long
Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function GetLastError Lib "kernel32" () As Long
Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Dim TrazeniFajl As String, LogFl As String
Dim LastLine  As String

Sub Main()
Dim Line As String
If App.PrevInstance Then End ' Samo jedna instanca
LastLine = ""
TrazeniFajl = "C:\Test.txt" ' Upisati svoj fajl
LogFl = "C:\MyLog.txt" 'Upisati svoj log fajl
WLoop:
Line = VBGetFileTime(TrazeniFajl)
If Line = "" Then End
If Line <> LastLine Then LogAddLine LogFl, Line: LastLine = Line
Sleep 1000
GoTo WLoop
End Sub

Public Function VBGetFileTime(File As String) As String
On Error GoTo Err
Dim hFile As Long
Dim CreationTime As FileTime, LastAccessTime As FileTime, LastWriteTime As FileTime
Dim mTime As SYSTEMTIME
Dim sa As SECURITY_ATTRIBUTES
If File = "" Then GoTo Err
hFile = CreateFile(File, GENERIC_READ, FILE_SHARE_READ, sa, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)
If hFile = -1 Then GoTo Err
GetFileTime hFile, CreationTime, LastAccessTime, LastWriteTime
CloseHandle hFile
FileTimeToLocalFileTime LastAccessTime, LastAccessTime
FileTimeToSystemTime LastAccessTime, mTime
VBGetFileTime = CStr(mTime.wDay) & "/" & CStr(mTime.wMonth) & "/" & CStr(mTime.wYear) & " " & CStr(mTime.wHour) & ":" & CStr(mTime.wMinute) & ":" & CStr(mTime.wSecond)
Exit Function
Err:
VBGetFileTime = ""
Debug.Print Err.Description
End Function

Private Sub LogAddLine(LogFile As String, Line As String)
On Error GoTo Err
If LogFile = "" Or Line = "" Then GoTo Err
Dim fso, fs
Set fso = CreateObject("Scripting.FileSystemObject")
Set fs = fso.OpenTextFile(LogFile, 8, True)
fs.WriteLine (Line)
fs.Close
Exit Sub
Err:

End Sub

